/* ====================================
		ݒ
==================================== */
#include "stdafx.h"
#include "gdippManager.h"
#pragma comment(lib, "comctl32.lib")
#pragma comment(lib, "comdlg32.lib")
#pragma comment(lib, "gdi32.lib")

/****/
//#define MAXFONTLISTBUF (LF_FACESIZE*32+40)
const UINT MAX_LIST = 32;
const UINT MAXFONTLISTBUF = LF_FACESIZE * MAX_LIST + MAX_LIST + 1;
const UINT MODULENAME_SIZE = 80;
const UINT MAXMODULELISTBUF = MODULENAME_SIZE * MAX_LIST + MAX_LIST + 1;

typedef struct {
	UINT Quality;
	UINT Weight;
	UINT Enhance;
	UINT MaxHeight;
	UINT UseSubPixel;
	UINT SubPixelDirection;
	UINT ForceAntialiasedQuality;
	WCHAR FontNames[MAXFONTLISTBUF];
	/****/
	WCHAR ModuleNames[MAXMODULELISTBUF];
	WCHAR IndividualNames[MAXFONTLISTBUF];
	UINT IndividualWeights[MAX_LIST];
} TIniParam;
/****/
//TIniParam g_tIniParam;
//BOOL g_OptApply = FALSE;
static TIniParam *g_pIniParam = NULL;
static BOOL g_OptApply = FALSE;
static WCHAR g_IndivName[LF_FACESIZE];
static UINT g_IndivWeight;

/***/
//extern HINSTANCE g_hInstance, g_hInstDLL;

LRESULT CALLBACK Opt1DlgProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK Opt2DlgProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
/****/
LRESULT CALLBACK Opt3DlgProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK Opt4DlgProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
void LoadSettings();
void SaveSettings();


#ifdef UNICODE
BOOL OpenOptionDlg(HWND hWnd)
{
	/****/
	// ݒǂݍ
	g_pIniParam = new TIniParam;
	ZeroMemory(g_pIniParam, sizeof(TIniParam));
	LoadSettings();

	/****/
	PROPSHEETPAGE psp[4];
	PROPSHEETHEADER psh;

	ZeroMemory(psp, sizeof(psp));
	int i = 0;
	psp[i].dwSize = sizeof(PROPSHEETPAGE);
	psp[i].dwFlags = PSP_USETITLE;
	/***/
	psp[i].hInstance = GetModuleHandle(NULL);//g_hInstance;
	psp[i].pszTemplate = MAKEINTRESOURCE(IDD_OPTION1);
	psp[i].pfnDlgProc = (DLGPROC)Opt1DlgProc;
	psp[i].pszTitle = L"General";
	i++;
	psp[i].dwSize = sizeof(PROPSHEETPAGE);
	psp[i].dwFlags = PSP_USETITLE;
	/***/
	psp[i].hInstance = GetModuleHandle(NULL);//g_hInstance;
	psp[i].pszTemplate = MAKEINTRESOURCE(IDD_OPTION2);
	psp[i].pfnDlgProc = (DLGPROC)Opt2DlgProc;
	psp[i].pszTitle = L"Exclude";
	/****/
	i++;
	psp[i].dwSize = sizeof(PROPSHEETPAGE);
	psp[i].dwFlags = PSP_USETITLE;
	psp[i].hInstance = GetModuleHandle(NULL);
	psp[i].pszTemplate = MAKEINTRESOURCE(IDD_OPTION2);
	psp[i].pfnDlgProc = (DLGPROC)Opt3DlgProc;
	psp[i].pszTitle = L"ExcludeModule";
	i++;
	psp[i].dwSize = sizeof(PROPSHEETPAGE);
	psp[i].dwFlags = PSP_USETITLE;
	psp[i].hInstance = GetModuleHandle(NULL);
	psp[i].pszTemplate = MAKEINTRESOURCE(IDD_OPTION2);
	psp[i].pfnDlgProc = (DLGPROC)Opt4DlgProc;
	psp[i].pszTitle = L"Individual";

	ZeroMemory(&psh, sizeof(psh));

	psh.dwSize = sizeof(PROPSHEETHEADER);
	psh.dwFlags = PSH_NOAPPLYNOW | PSH_PROPSHEETPAGE;
	psh.hwndParent = hWnd;
	/***/
	psh.hInstance = GetModuleHandle(NULL);//g_hInstance;
	psh.pszCaption = L"ݒ";
	psh.nPages = sizeof(psp) / sizeof(PROPSHEETPAGE);
	psh.ppsp = (LPCPROPSHEETPAGE)&psp;

	g_OptApply = FALSE;
	PropertySheet(&psh);

	/****/
	// XVݒۑ
	if( g_OptApply )
		SaveSettings();

	delete g_pIniParam;

	return g_OptApply;
}

#endif
/****/
// g_tIniParam -> g_pIniParam
void LoadSettings()
{
	WCHAR szFileName[MAX_PATH + 1] = L"";
	/***/
	// DLL̃tpX擾
	//GetModuleFileName((HMODULE)g_hInstDLL, szFileName, MAX_PATH);
	// t@Cu
	lstrcpy(szFileName, g_dllPath);
	WCHAR *sp = wcsrchr(szFileName, L'\\');
	lstrcpy(sp, INI_NAME);

	if( GetFileAttributes(szFileName) < 0 ) {
		MessageBox(NULL, L"INIt@C܂B\r\nVK쐬ɂȂ܂B",
					L"gdi++Manager", MB_ICONASTERISK|MB_TOPMOST);
	}

	// [General]ǂݍ
	const WCHAR GENERAL[] = L"General";
	// Quality
	g_pIniParam->Quality = GetPrivateProfileInt(GENERAL, L"Quality", 1, szFileName);
	if( g_pIniParam->Quality < 0 ) g_pIniParam->Quality = 0;
	else if( g_pIniParam->Quality > 3 ) g_pIniParam->Quality = 3;
	// Weight
	g_pIniParam->Weight = GetPrivateProfileInt(GENERAL, L"Weight", 0, szFileName);
	if( g_pIniParam->Weight < 0 ) g_pIniParam->Weight = 0;
	// Enhance
	g_pIniParam->Enhance = GetPrivateProfileInt(GENERAL, L"Enhance", 0, szFileName);
	if( g_pIniParam->Enhance < 0 ) g_pIniParam->Enhance = 0;
	else if( g_pIniParam->Enhance > 4 ) g_pIniParam->Enhance = 4;
	// MaxHeight
	g_pIniParam->MaxHeight = GetPrivateProfileInt(GENERAL, L"MaxHeight", 0, szFileName);
	if( g_pIniParam->MaxHeight < 0 ) g_pIniParam->MaxHeight = 0;
	// UseSubPixel
	g_pIniParam->UseSubPixel = GetPrivateProfileInt(GENERAL, L"UseSubPixel", 0, szFileName);
	g_pIniParam->UseSubPixel = (g_pIniParam->UseSubPixel == 0) ? 0 : 1;
	// SubPixelDirection
	g_pIniParam->SubPixelDirection = GetPrivateProfileInt(GENERAL, L"SubPixelDirection", 0, szFileName);
	g_pIniParam->SubPixelDirection = (g_pIniParam->SubPixelDirection == 0) ? 0 : 1;
	// ForceAntialiasedQuality
	g_pIniParam->ForceAntialiasedQuality = GetPrivateProfileInt(GENERAL, L"ForceAntialiasedQuality", 0, szFileName);
	g_pIniParam->ForceAntialiasedQuality = (g_pIniParam->ForceAntialiasedQuality == 0) ? 0 : 1;

	// [Exclude]ǂݍ
	GetPrivateProfileSection(L"Exclude", g_pIniParam->FontNames, MAXFONTLISTBUF, szFileName);

	/****/
	// [ExcludeModule]ǂݍ
	GetPrivateProfileSection(L"ExcludeModule", g_pIniParam->ModuleNames, MAXMODULELISTBUF, szFileName);

	// [Individual]ǂݍ
	const WCHAR INDIVIDUAL[] = L"Individual";
	GetPrivateProfileString(INDIVIDUAL, NULL, L"", g_pIniParam->IndividualNames, MAXFONTLISTBUF, szFileName);
	sp = g_pIniParam->IndividualNames;
	int i = 0;
	while( *sp ) {
		g_pIniParam->IndividualWeights[i++] = GetPrivateProfileInt(INDIVIDUAL, sp, 0, szFileName);
		sp += lstrlen(sp) + 1;
	}
}

void WritePrivateProfileInt(LPCTSTR lpAppName, LPCTSTR lpKeyName, int Value, LPCTSTR lpFileName)
{
	WCHAR str[8];
	/***/
	//swprintf(str, L"%d", Value);
	wsprintf(str, L"%d", Value);
	WritePrivateProfileString(lpAppName, lpKeyName, str, lpFileName);
}

void SaveSettings()
{
	WCHAR szFileName[MAX_PATH + 1] = L"";
	/***/
	// DLL̃tpX擾
	//GetModuleFileName((HMODULE)g_hInstDLL, szFileName, MAX_PATH);
	// t@Cu
	lstrcpy(szFileName, g_dllPath);
	WCHAR *sp = wcsrchr(szFileName, L'\\');
	lstrcpy(sp, INI_NAME);

	// [General]ۑ
	const WCHAR GENERAL[] = L"General";
	WritePrivateProfileInt(GENERAL, L"Quality", g_pIniParam->Quality, szFileName);
	WritePrivateProfileInt(GENERAL, L"Weight", g_pIniParam->Weight, szFileName);
	WritePrivateProfileInt(GENERAL, L"Enhance", g_pIniParam->Enhance, szFileName);
	WritePrivateProfileInt(GENERAL, L"MaxHeight", g_pIniParam->MaxHeight, szFileName);
	WritePrivateProfileInt(GENERAL, L"UseSubPixel", g_pIniParam->UseSubPixel, szFileName);
	if( g_pIniParam->UseSubPixel )
		WritePrivateProfileInt(GENERAL, L"SubPixelDirection", g_pIniParam->SubPixelDirection, szFileName);
	WritePrivateProfileInt(GENERAL, L"ForceAntialiasedQuality", g_pIniParam->ForceAntialiasedQuality, szFileName);
	// [Exclude]ۑ
	const WCHAR EXCLUDE[] = L"Exclude";
	WritePrivateProfileSection(EXCLUDE, NULL, szFileName);
	WritePrivateProfileSection(EXCLUDE, g_pIniParam->FontNames, szFileName);
	// [ExcludeModule]ۑ
	const WCHAR EXMODULE[] = L"ExcludeModule";
	WritePrivateProfileSection(EXMODULE, NULL, szFileName);
	WritePrivateProfileSection(EXMODULE, g_pIniParam->ModuleNames, szFileName);
	// [Individual]ۑ
	const WCHAR INDIVIDUAL[] = L"Individual";
	sp = g_pIniParam->IndividualNames;
	int i=0;
	while( *sp ) {
		WritePrivateProfileInt(INDIVIDUAL, sp, g_pIniParam->IndividualWeights[i++], szFileName);
		sp += lstrlen(sp) + 1;
	}
}

void InitGeneral(HWND hWnd)
{
	HWND hw;
	// Quality
	hw = GetDlgItem(hWnd, IDC_QUALITY);
	ComboBox_AddString(hw, L"OSW");
	ComboBox_AddString(hw, L"2{LC");
	ComboBox_AddString(hw, L"3{LC");
	ComboBox_AddString(hw, L"4{LC");
	ComboBox_SetCurSel(hw, g_pIniParam->Quality);
	// Weight
	hw = GetDlgItem(hWnd, IDC_WEIGHT_SPIN);
	/****/
	SendMessage(hw, UDM_SETRANGE, 0, MAKELPARAM(32, 0));	//Ƃ肠ő4->32
	SendMessage(hw, UDM_SETPOS, 0, (LPARAM)g_pIniParam->Weight);
	// Enhance
	hw = GetDlgItem(hWnd, IDC_ENHANCE);
	ComboBox_AddString(hw, L"Ȃ");
	ComboBox_AddString(hw, L"");
	ComboBox_AddString(hw, L"ʂɋ");
	ComboBox_AddString(hw, L"");
	ComboBox_AddString(hw, L"");
	ComboBox_SetCurSel(hw, g_pIniParam->Enhance);
	// MaxHeight
	hw = GetDlgItem(hWnd, IDC_MAXSIZE_SPIN);
	SendMessage(hw, UDM_SETRANGE, 0, MAKELPARAM(64, 0));	//Ƃ肠ő64
	SendMessage(hw, UDM_SETPOS, 0, (LPARAM)g_pIniParam->MaxHeight);
	// UseSubPixel, SubPixelDirection
	if( g_pIniParam->UseSubPixel == 0 )
		CheckRadioButton(hWnd, IDC_SUBPIX_OFF, IDC_SUBPIX_BGR, IDC_SUBPIX_OFF);
	else
		CheckRadioButton(hWnd, IDC_SUBPIX_OFF, IDC_SUBPIX_BGR, IDC_SUBPIX_RGB+g_pIniParam->SubPixelDirection);
	// ForceAntialiasedQuality
	Button_SetCheck(GetDlgItem(hWnd, IDC_NO_CLEARTYPE), g_pIniParam->ForceAntialiasedQuality);
}

void InitExclude(HWND hWnd)
{
	HWND hList = GetDlgItem(hWnd, IDC_FONT_LIST);
	WCHAR *sp = g_pIniParam->FontNames;
	while( *sp ) {
		ListBox_AddString(hList, sp);
		sp += lstrlen(sp) + 1;
	}
}

void InitExModule(HWND hWnd)
{
	HWND hList = GetDlgItem(hWnd, IDC_FONT_LIST);
	WCHAR *sp = g_pIniParam->ModuleNames;
	while( *sp ) {
		ListBox_AddString(hList, sp);
		sp += lstrlen(sp) + 1;
	}
}

void InitIndividual(HWND hWnd)
{
	HWND hList = GetDlgItem(hWnd, IDC_FONT_LIST);
	WCHAR *sp = g_pIniParam->IndividualNames;
	WCHAR buf[LF_FACESIZE + 8];
	int i = 0;
	while( *sp ) {
		wsprintf(buf, L"%s F%d", sp, g_pIniParam->IndividualWeights[i++]);
		ListBox_AddString(hList, buf);
		sp += lstrlen(sp) + 1;
	}
}

void ApplyGeneral(HWND hWnd)
{
	// Quality
	g_pIniParam->Quality = ComboBox_GetCurSel(GetDlgItem(hWnd, IDC_QUALITY));
	if( g_pIniParam->Quality == CB_ERR ) g_pIniParam->Quality = 0;
	// Weight
	g_pIniParam->Weight = GetDlgItemInt(hWnd, IDC_WEIGHT_NUM, NULL, FALSE);
	// Enhance
	g_pIniParam->Enhance = ComboBox_GetCurSel(GetDlgItem(hWnd, IDC_ENHANCE));
	if( g_pIniParam->Enhance == CB_ERR ) g_pIniParam->Enhance = 0;
	// MaxHeight
	g_pIniParam->MaxHeight = GetDlgItemInt(hWnd, IDC_MAXSIZE_NUM, NULL, FALSE);
	// UseSubPixel,
	g_pIniParam->UseSubPixel = IsDlgButtonChecked(hWnd, IDC_SUBPIX_OFF) ? 0 : 1;
	// SubPixelDirection
	if( g_pIniParam->UseSubPixel )
		g_pIniParam->SubPixelDirection = IsDlgButtonChecked(hWnd, IDC_SUBPIX_RGB) ? 0 : 1;
	// ForceAntialiasedQuality
	g_pIniParam->ForceAntialiasedQuality = IsDlgButtonChecked(hWnd, IDC_NO_CLEARTYPE) ? 1 : 0;
}

void ApplyExclude(HWND hWnd)
{
	HWND hList = GetDlgItem(hWnd, IDC_FONT_LIST);
	WCHAR *sp = g_pIniParam->FontNames;
	int n = ListBox_GetCount(hList);
	/****/
//	if( n > 32 ) n = 32;
	if( n > MAX_LIST ) n = MAX_LIST;
	for(int i=0; i < n ;i++) {
		ListBox_GetText(hList, i, sp);
		sp += lstrlen(sp) + 1;
	}
	*sp = 0;
}

/****/
void ApplyExModule(HWND hWnd)
{
	HWND hList = GetDlgItem(hWnd, IDC_FONT_LIST);
	WCHAR *sp = g_pIniParam->ModuleNames;
	int n = ListBox_GetCount(hList);
	if( n > MAX_LIST ) n = MAX_LIST;
	for(int i=0; i < n ;i++) {
		ListBox_GetText(hList, i, sp);
		sp += lstrlen(sp) + 1;
	}
	*sp = 0;
}

/****/
void ApplyIndividual(HWND hWnd)
{
	HWND hList = GetDlgItem(hWnd, IDC_FONT_LIST);
	WCHAR *sp = g_pIniParam->IndividualNames;
	int n = ListBox_GetCount(hList);
	if( n > MAX_LIST ) n = MAX_LIST;
	WCHAR buf[LF_FACESIZE+8];
	int k = 0;
	for(int i=0; i < n ;i++) {
		ListBox_GetText(hList, i, buf);
		WCHAR *bp = wcsstr(buf, L" F");
		if(*bp) {
			swscanf(bp, L" F%d", &g_pIniParam->IndividualWeights[k++]);
			*bp = 0;
			lstrcpy(sp, buf);
			sp += lstrlen(sp) + 1;
		}
	}
	*sp = 0;
}

// General
LRESULT CALLBACK Opt1DlgProc(HWND hDlg, UINT message, WPARAM /*wParam*/, LPARAM lParam)
{
	NMHDR *nmhdr;

	switch(message) {
	case WM_INITDIALOG:
		InitGeneral(hDlg);
		return TRUE;

	case WM_NOTIFY: nmhdr = (NMHDR *)lParam;
		switch(nmhdr->code) {
		case PSN_APPLY:
			ApplyGeneral(hDlg);
			g_OptApply = TRUE;
			break;
		default:
			return FALSE;
		}
		break;
	}
	return FALSE;
}

// Exclude
LRESULT CALLBACK Opt2DlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	NMHDR *nmhdr;
	HWND hw;
	CHOOSEFONT cf;
	LOGFONT lf;

	switch(message) {
	case WM_INITDIALOG:
		InitExclude(hDlg);
		return TRUE;

	case WM_COMMAND:
		switch(LOWORD(wParam)) {
		case IDC_FONT_ADD:
			/****/
			hw = GetDlgItem(hDlg, IDC_FONT_LIST);
			if( ListBox_GetCount(hw) == MAX_LIST ) {
				WCHAR buf[80];
				wsprintf(buf, L"w %d ܂łɂĂB", MAX_LIST);
				MessageBox(hDlg, buf, L"gdi++ ݒ", MB_ICONASTERISK|MB_TOPMOST);
				break;
			}
			GetObject(GetStockObject(SYSTEM_FONT), sizeof(lf), &lf);
			ZeroMemory(&cf, sizeof(CHOOSEFONT));
			cf.lStructSize = sizeof(CHOOSEFONT);
			cf.hwndOwner = hDlg;
			cf.lpLogFont = &lf;
			cf.Flags = CF_FORCEFONTEXIST|CF_SCREENFONTS|CF_INITTOLOGFONTSTRUCT;
			cf.nFontType = SCREEN_FONTTYPE;
			if(ChooseFont(&cf) == TRUE) {
				/****/
				//hw = GetDlgItem(hDlg, IDC_FONT_LIST);
				if( ListBox_FindString(hw, -1, lf.lfFaceName) < 0 )
					ListBox_AddString(hw, lf.lfFaceName);
			}
			break;
		case IDC_FONT_DEL:
			hw = GetDlgItem(hDlg, IDC_FONT_LIST);
			ListBox_DeleteString(hw, ListBox_GetCurSel(hw));
			break;
		case IDC_FONT_CLEAR:
			ListBox_ResetContent(GetDlgItem(hDlg, IDC_FONT_LIST));
			break;
		}
		break;

	case WM_NOTIFY: nmhdr = (NMHDR *)lParam;
		switch(nmhdr->code) {
		case PSN_APPLY:
			ApplyExclude(hDlg);
			g_OptApply = TRUE;
			break;
		default:
			return FALSE;
		}
		break;
	}
	return FALSE;
}

// ExcludeModule
LRESULT CALLBACK Opt3DlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	NMHDR *nmhdr;
	HWND hw;
	OPENFILENAME ofn;
	WCHAR szName[MODULENAME_SIZE];

	switch(message) {
	case WM_INITDIALOG:
		InitExModule(hDlg);
		return TRUE;

	case WM_COMMAND:
		switch(LOWORD(wParam)) {
		case IDC_FONT_ADD:
			hw = GetDlgItem(hDlg, IDC_FONT_LIST);
			if( ListBox_GetCount(hw) == MAX_LIST ) {
				WCHAR buf[80];
				wsprintf(buf, L"w %d ܂łɂĂB", MAX_LIST);
				MessageBox(hDlg, buf, L"gdi++ ݒ", MB_ICONASTERISK|MB_TOPMOST);
				break;
			}
			szName[0] = 0;
			ZeroMemory(&ofn, sizeof(OPENFILENAME));
			ofn.lStructSize = sizeof(OPENFILENAME);
			ofn.hwndOwner = hDlg;
			ofn.lpstrFilter = L"All Files(*.*)\0*.*\0\0";
			ofn.nMaxFileTitle = MODULENAME_SIZE;
			ofn.lpstrFileTitle = szName;
			ofn.lpstrFile = NULL;
			ofn.nMaxFile = MAX_PATH;
			ofn.lpstrTitle = L"Select Exclude Module";
			ofn.Flags = OFN_HIDEREADONLY|OFN_NONETWORKBUTTON;
			if (GetOpenFileName(&ofn)) {
				if( ListBox_FindString(hw, -1, szName) < 0 )
					ListBox_AddString(hw, szName);
			}
			break;

		case IDC_FONT_DEL:
			hw = GetDlgItem(hDlg, IDC_FONT_LIST);
			ListBox_DeleteString(hw, ListBox_GetCurSel(hw));
			break;

		case IDC_FONT_CLEAR:
			ListBox_ResetContent(GetDlgItem(hDlg, IDC_FONT_LIST));
			break;
		}
		break;

	case WM_NOTIFY: nmhdr = (NMHDR *)lParam;
		switch(nmhdr->code) {
		case PSN_APPLY:
			ApplyExModule(hDlg);
			g_OptApply = TRUE;
			break;
		default:
			return FALSE;
		}
		break;
	}
	return FALSE;
}

// Individual FontI
LRESULT CALLBACK IndividualSelDlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	HWND hw;
	CHOOSEFONT cf;
	LOGFONT lf;

	switch(message) {
	case WM_INITDIALOG:
		SetDlgItemText(hDlg, IDC_FONTNAME, g_IndivName);
		hw = GetDlgItem(hDlg, IDC_WEIGHT_SPIN);
		SendMessage(hw, UDM_SETRANGE, 0, MAKELPARAM(32, 0));	//Ƃ肠ő32
		SendMessage(hw, UDM_SETPOS, 0, (LPARAM)g_IndivWeight);
		return TRUE;

	case WM_COMMAND:
		switch(LOWORD(wParam)) {
		case IDC_SELBTN:
			GetObject(GetStockObject(SYSTEM_FONT), sizeof(lf), &lf);
			ZeroMemory(&cf, sizeof(CHOOSEFONT));
			cf.lStructSize = sizeof(CHOOSEFONT);
			cf.hwndOwner = hDlg;
			cf.lpLogFont = &lf;
			cf.Flags = CF_FORCEFONTEXIST|CF_SCREENFONTS|CF_INITTOLOGFONTSTRUCT;
			cf.nFontType = SCREEN_FONTTYPE;
			if(ChooseFont(&cf) == TRUE) {
				SetDlgItemText(hDlg, IDC_FONTNAME, lf.lfFaceName);
			}
			break;
		case IDOK:
			GetDlgItemText(hDlg, IDC_FONTNAME, g_IndivName, LF_FACESIZE);
			g_IndivWeight = GetDlgItemInt(hDlg, IDC_WEIGHT_NUM, NULL, FALSE);
			EndDialog(hDlg, TRUE);
			break;

		case IDCANCEL:
			EndDialog(hDlg, FALSE);
			break;
		}
		break;
	}
	return FALSE;
}

// Individual
LRESULT CALLBACK Opt4DlgProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	NMHDR *nmhdr;
	HWND hw;
	WCHAR buf[LF_FACESIZE + 8], *sp;
	int i;

	switch(message) {
	case WM_INITDIALOG:
		InitIndividual(hDlg);
		return TRUE;

	case WM_COMMAND:
		switch(LOWORD(wParam)) {
		case IDC_FONT_ADD:
			hw = GetDlgItem(hDlg, IDC_FONT_LIST);
			if( ListBox_GetCount(hw) == MAX_LIST ) {
				WCHAR buf[80];
				wsprintf(buf, L"w %d ܂łɂĂB", MAX_LIST);
				MessageBox(hDlg, buf, L"gdi++ ݒ", MB_ICONASTERISK|MB_TOPMOST);
				break;
			}
			i = ListBox_GetCurSel(hw);
			g_IndivName[0] = 0;
			g_IndivWeight = 0;
			if( i >= 0 ) {
				ListBox_GetText(hw, i, buf);
				sp = wcsstr(buf, L" F");
				if(*sp) {
					swscanf(sp, L" F%d", &g_IndivWeight);
					*sp = 0;
					lstrcpy(g_IndivName, buf);
				}
			}
			if( DialogBox(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_OPTION3), hDlg, (DLGPROC)IndividualSelDlgProc) ) {
				int count = ListBox_GetCount(hw);
				for(i=0; i < count ;i++) {
					ListBox_GetText(hw, i, buf);
					sp = wcsstr(buf, L" F");
					if(*sp) {
						*sp = 0;
						if( !lstrcmp(buf, g_IndivName) ) break;
					}
				}
				if( i < count )
					ListBox_DeleteString(hw, i);
				wsprintf(buf, L"%s F%d", g_IndivName, g_IndivWeight);
				ListBox_AddString(hw, buf);
			}
			break;

		case IDC_FONT_DEL:
			hw = GetDlgItem(hDlg, IDC_FONT_LIST);
			ListBox_DeleteString(hw, ListBox_GetCurSel(hw));
			break;

		case IDC_FONT_CLEAR:
			ListBox_ResetContent(GetDlgItem(hDlg, IDC_FONT_LIST));
			break;
		}
		break;

	case WM_NOTIFY: nmhdr = (NMHDR *)lParam;
		switch(nmhdr->code) {
		case PSN_APPLY:
			ApplyIndividual(hDlg);
			g_OptApply = TRUE;
			break;
		default:
			return FALSE;
		}
		break;
	}
	return FALSE;
}
